/*
 * DOS partition table format;
 * the limited subset used by Solaris,
 * recast defined in byte-stream form
 * corresponds to Solaris <sys/dktp/fdisk.h>
 */

#define	frdospchar(p, o)	(((unsigned char *)(p))[o])	
#define	frdospword(p, o)	((((unsigned char *)(p))[(o)+1]<<8)|\
				 ((unsigned char *)(p))[(o)+0])
#define	frdosplong(p, o)	((((unsigned char *)(p))[(o)+3]<<24)|\
				 (((unsigned char *)(p))[(o)+2]<<16)|\
				 (((unsigned char *)(p))[(o)+1]<<8)|\
				 ((unsigned char *)(p))[(o)+0])
#define	todospchar(p, o, v)	(p)[o] = (v)&0xff
#define	todospword(p, o, v)	(p)[(o)+1] = ((v)>>8)&0xff,\
				(p)[(o)+0] = ((v)&0xff)
#define	todosplong(p, o, v)	(p)[(o)+3]=((v)>>24)&0xff,\
				(p)[(o)+2]=((v)>>16)&0xff,\
				(p)[(o)+1]=((v)>>8)&0xff,\
				(p)[(o)+0]=(v)&0xff

/*
 * a single partition entry
 */
#define	DOSP_BOOTID	0	/* (c) bootable or not */
#define	DOSP_STHEAD	1	/* (c) starting head number */
#define	DOSP_STSEC	2	/* (c) six bits of sector, two of head */
#define	DOSP_STCYL	3	/* (c) remainder of head */
#define	DOSP_SYSID	4	/* (c) system ID (partition type) */
#define	DOSP_ENDHEAD	5	/* (c) ending head number */
#define	DOSP_ENDSEC	6	/* (c) six bits of sector, two of head */
#define	DOSP_ENDCYL	7	/* (c) remainder of head */
#define	DOSP_STLBA	8	/* (l) first LBA */
#define	DOSP_LBASZ	12	/* (l) size in LBAs */

#define	LEN_DOSP	16

#define	BSEC_BOOTCODE	0	/* magic 446 bytes */
#define	BSEC_PARTS	446	/* 4 * LEN_DOSP */
#define	BSEC_MAGIC	510	/* (w) magic number */

#define	LEN_BSEC	512

#define	BSEC_LOC	0	/* LBA of boot sector */

#define	BSECMAGIC	0xaa55

/*
 * the only sysids that matter to our code
 */
#define	SYSID_SUNOS	130
#define	SYSID_SUNOS2	191
