/*
 * architecture-independent description
 * of EFI disk labels
 *
 * in general, names taken from Solaris efi_partition.h header file
 */

/*
 * data-type access macros
 */
#define	frefiword(p, o)	((((unsigned char *)(p))[(o)+1]<<8)|\
				 ((unsigned char *)(p))[(o)+0])
#define	frefilong(p, o)	((((unsigned char *)(p))[(o)+3]<<24)|\
				 (((unsigned char *)(p))[(o)+2]<<16)|\
				 (((unsigned char *)(p))[(o)+1]<<8)|\
				 ((unsigned char *)(p))[(o)+0])
#define	frefill(p, o)	(((unsigned long long)(((unsigned char *)(p))[(o)+7])<<56)|\
			 ((unsigned long long)(((unsigned char *)(p))[(o)+6])<<48)|\
			 ((unsigned long long)(((unsigned char *)(p))[(o)+5])<<40)|\
			 ((unsigned long long)(((unsigned char *)(p))[(o)+4])<<32)|\
			 ((unsigned long long)(((unsigned char *)(p))[(o)+3])<<24)|\
			 ((unsigned long long)(((unsigned char *)(p))[(o)+2])<<16)|\
			 ((unsigned long long)(((unsigned char *)(p))[(o)+1])<<8)|\
			 ((unsigned long long)((unsigned char *)(p))[(o)+0]))

#define	toefiword(p, o, v)	(p)[(o)+1] = ((v)>>8)&0xff,\
				(p)[(o)+0] = ((v)&0xff)
#define	toefilong(p, o, v)	(p)[(o)+3]=((v)>>24)&0xff,\
				(p)[(o)+2]=((v)>>16)&0xff,\
				(p)[(o)+1]=((v)>>8)&0xff,\
				(p)[(o)+0]=(v)&0xff
#define	toefill(p, o, v)	(p)[(o)+7]=((v)>>54)&0xff,\
				(p)[(o)+6]=((v)>>48)&0xff,\
				(p)[(o)+5]=((v)>>40)&0xff,\
				(p)[(o)+4]=((v)>>32)&0xff, \
				(p)[(o)+3]=((v)>>24)&0xff,\
				(p)[(o)+2]=((v)>>16)&0xff,\
				(p)[(o)+1]=((v)>>8)&0xff,\
				(p)[(o)+0]=(v)&0xff

/*
 * size of a uuid (Solaris struct uuid)
 * has some internal structure,
 * but for our purposes it's just an opaque cookie
 */
#define	LEN_UUID	16

/*
 * offsets into partition table header
 */

#define	GPT_SIGNATURE		0	/* (ll) */
#define	GPT_REVISION		8	/* (l) */
#define	GPT_HEADERSIZE		12	/* (l) */
#define	GPT_HEADERCRC32		16	/* (l) */
#define	GPT_RESERVED1		20	/* (l) */
#define	GPT_MYLBA		24	/* (ll) */
#define	GPT_ALTERNATELBA	32	/* (ll) */
#define	GPT_FIRSTUSABLELBA	40	/* (ll) */
#define	GPT_LASTUSABLELBA	48	/* (ll) */
#define	GPT_DISKGUID		56	/* (LEN_UUID) */
#define	GPT_PARTITIONENTRYLBA	72	/* (ll) */
#define	GPT_NUMBEROFPARTITIONENTRIES 80	/* (l) */
#define	GPT_SIZEOFPARTITIONENTRY 84	/* (l) */
#define	GPT_PARTITIONENTRYARRAYCRC32 88	/* (l) */

#define	MINLEN_GPT	96	/* sic -- four junk bytes must be present */
#define	LEN_GPT	512

#define	EFI_GPT_LOC	1	/* sector number of primary copy */
/* secondary copy is last sector of the disk */

/*
 * a single partition entry
 */

#define	LEN_PARTITIONNAME	36

#define	GPE_PARTITIONTYPEGUID	0	/* (LEN_UUID) */
#define	GPE_UNIQUEPARTITIONGUID	16	/* (LEN_UUID) */
#define	GPE_STARTINGLBA		32	/* (ll) */
#define	GPE_ENDINGLBA		40	/* (ll) */
#define	GPE_ATTRIBUTES		48	/* (ll) */
#define	GPE_PARTITIONNAME	56	/* (LEN_PARTITIONNAME) */

#define	LEN_GPE	128
