/*
 * Copyright 2005 Coraid, Inc.
 * See accompanying file pkg/LICENSE for conditions
 */

/*
 * 32-bit-model versions of the data structures
 * described in <sys/dktp/dadkio.h>
 * needed so a 64-bit-kernel driver can handle ioctl calls
 * from 32-bit programs, usually /usr/sbin/format
 * why doesn't Sun supply this stuff as they do for
 * other disk ioctl calls?  I wish I knew.
 *
 * the official header file must already have been included
 */

/*
 * dadkio_status status value.
 */
struct dadkio32_status {
	int32_t		status;
	uint32_t	resid;
	int32_t		failed_blk_is_valid;
	int32_t		failed_blk;
	int32_t		fru_code_is_valid;
	int32_t		fru_code;
	char		add_error_info[DADKIO_ERROR_INFO_LEN];
};

/*
 * Used by read/write ioctl (DKIOCTL_RWCMD)
 */
struct dadkio32_rwcmd {
	int32_t			cmd;
	int32_t			flags;
	uint32_t		blkaddr;
	uint32_t		buflen;
	uint32_t		bufaddr;
	struct dadkio32_status	status;
};
