/*
 * Copyright 2005 Coraid, Inc.
 * See accompanying file doc/LICENSE for conditions
 */

/*
 * common defs for library routines
 * used by various aoe control commands
 */

/*
 * default device names
 */
#define	AOECOMM	"aoecomm"	/* line discipline */
#define	AOECTL	"/dev/aoectl"	/* control device */
#define	AOEMON	"/dev/aoemon"	/* monitoring device */

/* achan.c */

char *achdir(char *);
int achattach(int, int);	/* fd, chan */
int achdetach(int);

/* comm.c */

int comminit(int, char *, int, int, char *);
		/* channel, interface, proto, maxdata, ret-addr */

/* log.c */

void loginit(char *, int);
void logpkt(int, char *, int);
char *ethertoa(char *, char *);		/* address, buffer */
void loghex(int, char *, int);
void logmsg(int, char *, ...);

#define	LTYPE	07
#define	LD	0	/* debug message */
#define	LI	01	/* status info */
#define	LN	02	/* notice, more important than status, less than error */
#define	LE	03	/* error */

#define	LS	010	/* print to stderr regardless */

/* debug.c */

extern int debug;
extern int verbose;

/* trdwr.c */

int tread(int, void *, int, int);
int twrite(int, void *, int, int);
