/*
 * Copyright 2005 Coraid, Inc.
 * See accompanying file doc/LICENSE for conditions
 */

/*
 * shut down AoE channels
 */

#include <stdio.h>
#include <stdlib.h>
#include "aoecmd.h"

static char *progname = "aoestop";
static int doall;

static char **doargs(char **);
static void usage(void);

int
main(argc, argv)
int argc;
char **argv;
{
	int chan;
	char *ep;
	int e;
	int ret;

	if (argc > 0)
		progname = *argv++;
	argv = doargs(argv);
	if (doall) {
		if (*argv)
			usage();
		if (achdetach(-1) < 0) {
			fprintf(stderr, "%s: detach-all failed\n");
			return (1);
		}
		return (0);
	} else {
		if (*argv == NULL)
			usage();
		ret = 0;
		for (; *argv; argv++) {
			chan = strtol(*argv, &ep, 0);
			if (chan < 0 || *ep) {
				fprintf(stderr, "%s: invalid aoechan %s ignored\n",
					progname, *argv);
				ret = 1;
			} else if ((e = achdetach(chan)) < 0) {
				fprintf(stderr, "%s: detach %s failed\n",
					progname, *argv);
				ret = 1;
			} else if (e == 0)
				fprintf(stderr, "%s: detach %s: not active\n",
					progname, *argv);
		}
		return (ret);
	}
}

static char **
doargs(av)
char **av;
{
	char *p;

	for (; *av && **av == '-'; av++)
	for (p = &av[0][1]; *p; p++)
	switch (*p) {
	case 'a':
		doall = 1;
		continue;

	case 'v':
		verbose = 1;
		continue;

	default:
		usage();
	}
	return (av);
}

static void
usage()
{
	fprintf(stderr, "usage: %s [-v] [-a | aoechan ...]\n", progname);
	exit(1);
}
